#!/usr/bin/env python

try:
	from dpipes_curl import curl, CURLAuth
	class cUrl:
		def __init__(self, request_type='GET', headers=None, timeout=None, use_gzip=True):
			self.args=dict({'auth':None, 'req_type':request_type, 'headers':headers, 'timeout':timeout, 'use_gzip':use_gzip})
		
		def auth(self, user, password, force=False, headers=None):
			ret=CURLAuth(user, password, force, headers)
			self.args.update({'auth':ret})
			return ret
		
		def get(self, url, params=None, auth=None, req_type=None, data=None, headers=None, timeout=None, use_gzip=True):
			if auth is None:
				auth=self.args['auth']
			if req_type is None:
				req_type=self.args['req_type']
			if headers is None:
				headers=self.args['headers']
			if timeout is None:
				timeout=self.args['timeout']
			if use_gzip is None:
				use_gzip=self.args['use_gzip']
			ret=curl(url, params, auth, req_type, data, headers, timeout, use_gzip)
			return ret
except:
	pass


try:
	import dpipes_pfs
	class PortFs(dpipes_pfs.PortFs):
		def dummy(self):
			return False
except:
	pass


try:
	import dpipes_zeroconf
	class BonjourRegister(dpipes_zeroconf.BonjourRegister):
		def dummy(self):
			return False

	class BonjourResolve(dpipes_zeroconf.BonjourResolve):
		def dummy(self):
			return False
except:
	pass


try:
	import dpipes_netio
	class NetioServer(dpipes_netio.NetioServer):
		def dummy(self):
			return False

	class NetioClient(dpipes_netio.NetioClient):
		def dummy(self):
			return False
	
	def NetioAddress(family, target, port=0):
		return dpipes_netio.NetioAddress(family, target, port)
except:
	pass


def DbdBearer(server_type):
	try:
		if server_type=='mysql':
			from dbd_mysql import DbDriver
		elif server_type=='sqlite':
			from dbd_sqlite import DbDriver
		return True
	except:
		return False
		pass
