#!/usr/bin/env python

import gi
gi.require_version('Gtk', '3.0')
from gi.repository import Gtk, GObject, WebKit

class WebAppClient:
	def __init__(self, args=dict({})):
		self.gtk=Gtk
		self.gobj=GObject
		self.wkit=WebKit
		
		self.args=dict({'w_role':'WebAppClientMain', 'w_icon':'', 'w_title':'Untitled WebAppClient', 'w_size_def':[-1, -1], 'w_size_req':[-1, -1], 'w_position':[-1, -1], 'w_fullscreen':False, 'app_splash_timer':-1, 'app_splash_uri':'', 'app_main_uri':'about:blank'})
		self.args.update(args)
	
	def start(self):
		self.createWindow()
		self.createWebView()
		if self.args['app_splash_timer']>-1:
			self.loadContent(self.args['app_splash_uri'])
			self.postSplashTimer=self.gobj.timeout_add(self.args['app_splash_timer']*1000, self.postSplash)
		else:
			self.loadContent(self.args['app_main_uri'])
		
		self.wMain.show_all()
		self.gtk.main()
	
	
	def createWindow(self):
		self.wMain = self.gtk.Window()
		self.wMain.connect('delete-event', self.gtk.main_quit)
		
		self.wMain.set_can_focus(True)
		self.wMain.set_position(self.gtk.WindowPosition.MOUSE)
		self.wMain.set_role(self.args['w_role'])
		self.wMain.set_decorated(True)
		self.wMain.set_title(self.args['w_title'])
		if self.args['w_icon']!='':
			self.wMain.set_icon_from_file(self.args['w_icon'])
		
		if self.args['w_size_def'][0]>-1 and self.args['w_size_def'][1]>-1:
			self.wMain.set_default_size(self.args['w_size_def'][0], self.args['w_size_def'][1])
		if self.args['w_size_req'][0]>-1 and self.args['w_size_req'][1]>-1:
			self.wMain.set_size_request(self.args['w_size_req'][0], self.args['w_size_req'][1])
		if self.args['w_position'][0]>-1 and self.args['w_position'][1]>-1:
			self.wMain.move(self.args['w_position'][0], self.args['w_position'][1])
		if self.args['w_fullscreen']==True:
			self.wMain.fullscreen()
	
	def createWebView(self):
		self.appMain = self.wkit.WebView()
		self.appMain.set_full_content_zoom(True)
		self.wMain.add(self.appMain)
	
	
	def loadContent(self, uri):
		self.appMain.load_uri(uri)
	
	def execScript(self, content):
		self.appMain.execute_script(content)
	
	
	def postSplash(self):
		self.loadContent(self.args['app_main_uri'])
		self.gobj.timeout_remove(self.postSplashTimer)
